class Entity:
    def __init__(self):
        self._components = []
        self.x = 0
        self.y = 0
        self.script = None

    def add(self, component):
        self._components.append(component)
        component.parent = self

    def register(self):
        for component in self._components:
            component.register()

    def unregister(self):
        for component in self._components:
            component.unregister()
